
///--------------------------------------FONCTIONS----------------------------------------------------
///deplacer_ennemi, suivre_joueur, trouve_chemin, init_tir,attirer_sort, deplacer_tir, deplacer_joueur, fin_ennemi,fin_jeu,ma_pause,nettoyer_memoire




struct Ennemi deplacer_ennemi(char carte[][NB_BLOCS_HAUTEUR],struct Ennemi monstre, struct Joueur joueur, struct Arme Tir, long *score)
{	int proba_echap= (int) ((double)rand() / ((double)RAND_MAX + 1)*100 );
    if(((monstre.Position.x+monstre.sens.x==Tir.Position.x &&  monstre.Position.y+monstre.sens.y==Tir.Position.y)
    ||  (monstre.Position.x==Tir.Position.x &&  monstre.Position.y==Tir.Position.y))  )//analyse de la prochaine case pour tentative d'equive du tir
    {           
        if( Tir.sens.x==0 && Tir.sens.y==0)//si le tir est arreté l'ennemi fait demi tour
        {	    monstre.sens.x=-monstre.sens.x;
                monstre.sens.y=-monstre.sens.y;
                monstre.Position.x=monstre.Position.x+monstre.sens.x;
                monstre.Position.y=monstre.Position.y+monstre.sens.y;
        }
        else
        {        
          /*  if(proba_echap>0 && carte[monstre.Position.x-monstre.sens.x][monstre.Position.y-monstre.sens.y]==' ' )
            {
                monstre.sens.x=-monstre.sens.x;
                monstre.sens.y=-monstre.sens.y;
                monstre.Position.y=monstre.Position.y+monstre.sens.y; // On bouge Ennemi
                monstre.Position.x=monstre.Position.x+monstre.sens.x;
            }
            else*/
            monstre=fin_ennemi(carte,monstre,&Tir,score);
        }
    }
else //Sinon pas tir ou tir trop loin
{int proba_abandon = (int) ((double)rand() / ((double)RAND_MAX + 1)*100 );
		if(distance2<monstre.dist_Detection && proba_abandon>10)	//si probabilité le permet et si distance joueur-ennemi< distance de detection ennemi
		{
			monstre=suivre_joueur(monstre,joueur);//essayer de tuer (=SE RAPPROCHER) le joueur!
		}
				
		if(carte[monstre.Position.x+monstre.sens.x][monstre.Position.y+monstre.sens.y]==' ') //la prochaine case  est VIDE (' ').
		{
			monstre.Position.y=monstre.Position.y+monstre.sens.y; // On bouge Ennemi
			monstre.Position.x=monstre.Position.x+monstre.sens.x;
		}
		else //sinon la prochaine case est un obstacle "inerte"
		{
			monstre=trouve_chemin(monstre,carte);
		}
}

	
	return monstre;
}

struct Ennemi fin_ennemi(char carte[][NB_BLOCS_HAUTEUR],struct Ennemi monstre, struct Arme *Tir,long *score)
{
	monstre.Etat=0;
	Tir->Etat=0;
	EtatTir=0;
	carte[monstre.Position.x][monstre.Position.y]='8';
	Mix_PlayChannel(0, son[4], 0);
	Tir->sens.x=0; //Fin du Tir
	Tir->sens.y=0;
	Tir->Position.x=-100;//et on place le tir hors de la carte de jeu
	Tir->Position.y=-100;
	*score=*score+monstre.valeur;
return monstre;
}


///######################Attaquer=poursuivre joueur #################################################################
//On repère la position du joueur, on ajuste le sens de l'ennemi pour qu'il se rapproche
//cette fonction ne modifie que le sens de l'ennemi.
struct Ennemi  suivre_joueur(struct Ennemi monstre,struct Joueur joueur)
{
	if(monstre.Position.x-joueur.Position.x>0)//Si ennemi à droite de joueur, on met le sens vers la gauche
		monstre.sens.x=-1;
	else
	{
		if(monstre.Position.x-joueur.Position.x<0)//Si ennemi à gauche du joueur, on met le sens vers la droite
			monstre.sens.x=1;
		else
		{   monstre.sens.x=0;//ennemi sur même ligne que joueur : on ne change rien
		}
	}

	if(monstre.Position.y-joueur.Position.y>0)//Si ennemi au dessous de joueur, on met le sens vers le haut
	{	monstre.sens.y=-1;
	}
	else
	{
		if(monstre.Position.y-joueur.Position.y<0)//Si ennemi au dessus, on met le sens vers le bas
		{   monstre.sens.y=1;
		}
		else
		{   monstre.sens.y=0; //ennemi sur même colonne que joueur : on ne change rien
		}
	}
	return monstre;
}

  
 
///#######################################################################################
struct Ennemi  trouve_chemin(struct Ennemi monstre,char carte[][NB_BLOCS_HAUTEUR])
{//cette fonction ne modifie que le sens de l'ennemi. Elle teste les cases vides autour de l'ennemi et en choisit une au "hasard"
			/// ON STOCKE LES CASES LIBRES AUTOUR DE L'ENNEMI : boucle de test des cases autour de l'ennemi :
	struct Sens test_sens; //pour tester les différentes directions
	struct Sens sens_possible_diag[4]; //stocker les sens autorisés en diagonale; init avec chiffre !=0 ou 1 ??
	memset(sens_possible_diag,0, sizeof(sens_possible_diag));//init sens possible avec case vide
    struct Sens sens_possible_HV[4];//stocker les sens autorisés H ou V
    memset(sens_possible_HV,0, sizeof(sens_possible_HV));
	int cpt_diag=0;//nombre de cases vides en diagonal
	int cpt_HV=0; //nombre de cases vides H ou V

	for(test_sens.x=-1;test_sens.x<2;test_sens.x++) //on boucle sur les 8 cases autour de l'ennemi
	{
		for(test_sens.y=-1;test_sens.y<2;test_sens.y++)
		{//printf("carte : %c\n",carte[monstre.Position->x+test_sens.x][monstre.Position->y+test_sens.y]);
			if(carte[monstre.Position.x+test_sens.x][monstre.Position.y+test_sens.y]==' ') //Si case vide,
			{
				if(test_sens.x!=0 || test_sens.y!=0)  //seul test car si x=0 et y=0 pas dinteret!!
				{
					if(test_sens.x*test_sens.y==0)//alors on stocke H ou V
					{	sens_possible_HV[cpt_HV].x=test_sens.x;
						sens_possible_HV[cpt_HV].y=test_sens.y;
						cpt_HV++;//compteur pour deplacer H ou V
					}
					else//ou on stocke diag
					{	sens_possible_diag[cpt_diag].x=test_sens.x;
						sens_possible_diag[cpt_diag].y=test_sens.y;
						cpt_diag++; //compteur pour diagonale
					}
				}
			}
		}
	}//FIN ANALYSE des POSITIONS VIDE AUTOUR DE L'ENNEMI

			///-----------------tirage aléatoire POUR CHOISIR AU HASARD UNE DES CASES LIBRES TROUVEES AU DESSUS---------------
	int nb1 = (int) ((double)rand() / ((double)RAND_MAX + 1)*100 );//nombre aléatoire
			 			//compris entre 0 et 100 pour rendre un peu plus varié le déplacement
			 			//probabilité de déplacement  horizontale verticale
	int proba_HV=monstre.probaHV;
	//sinon diagonale
	int proba_diag=100-proba_HV;

	int test_nbHVsup=0;
	int testnbHVinf=0;

	int test_nbDiagsup=0;
	int testnbDiaginf=0;

//	int test_nbdiag=0;

	if(nb1<proba_HV)//DEPLACEMENT HORIZONTAL ET VERTICAL
	{
		for(int cpt=0;cpt<cpt_HV;cpt++)//balayage sur les cases vides
		{	test_nbHVsup=(int)(proba_HV*(1-((float)cpt/(float)cpt_HV)));
			testnbHVinf=(int)(proba_HV*(1-(float)(cpt+1)/(float)cpt_HV));
					//float ratio=(float)cpt/(float)cpt_HV;
					//printf("%d<=nb1<%d\n",testnbHVinf,test_nbHVsup);
					//printf("cpt_HV : %d,cpt %d\n",cpt_HV,cpt);
					//printf("test/cpt %f\n",ratio);
			if(nb1>=testnbHVinf && nb1<test_nbHVsup)
			{	monstre.sens.x=sens_possible_HV[cpt].x;
				monstre.sens.y=sens_possible_HV[cpt].y;
			}
		}
	}

	else //sinon distribuer de façon equiprobable selon les différentes diagonales
	{
		for(int cpt=0;cpt<cpt_diag;cpt++)
		{
			test_nbDiagsup=(int)(proba_diag*(1-((float)cpt/(float)cpt_diag)))+proba_HV;
			testnbDiaginf=(int)(proba_diag*(1-(float)(cpt+1)/(float)cpt_diag))+proba_HV;
					//printf("cpt_diag :%d\n",cpt_diag);
				//printf("%d<nb1<=%d\n",testnbDiaginf,test_nbDiagsup);

			if( (nb1>testnbDiaginf && nb1<=test_nbDiagsup) || (nb1==proba_HV) )//le dernier test sert  juste
			{				//à inclure proba_HV!! (lourd?)
				monstre.sens.x=sens_possible_diag[cpt].x;
				monstre.sens.y=sens_possible_diag[cpt].y;
			}
		}//printf("\n");
	}

return monstre;
}




///Fonction initialisant le tir : joue le son, fixe la position, l'etat et le sens (opposé au joueur)
struct Arme init_tir(SDL_Rect *pos,char carte[][NB_BLOCS_HAUTEUR], struct Arme Tir)
{
	if(carte[pos->x+Tir.sens.x][pos->y+Tir.sens.y]==' ') //prochaine     case vide : on peut tirer
	{
		Mix_PlayChannel(0, son[2], 0);
		Tir.Position.x=pos->x;
		Tir.Position.y=pos->y;
		EtatTir=1;
		Tir.Etat=1;
	}
	else //sinon garder le tir, mais emettre le bruit
	{
		Mix_PlayChannel(0, son[2], 0);
		Tir.Position.x=-1;
		Tir.Position.y=-1;
		Tir.sens.x=0;
		Tir.sens.y=0;
		EtatTir=0;
		Tir.Etat=0;
	}

return Tir;
}


struct Arme fin_tir(struct Arme Tir) //destructeur Tir
{
    Tir.Position.x=-222;
    Tir.Position.y=-222; 
    printf("fintir!\n");
    printf("Tir.Position.x",Tir.Position.x);
    Tir.sens.x=0;
    Tir.sens.y=0;
    Tir.Etat=0;
    EtatTir=0;
    return Tir;
}
///---------------------------------------------ATTRACTION TIR----------------------------------------
//lors d'un appui sur bouton, le tir est attiré vers joueur
//NE MODIFIE QUE LE SENS DU TIR
struct Arme attirer_sort(SDL_Rect *pos,char carte[][NB_BLOCS_HAUTEUR], struct Arme Tir)
{	
	Mix_PlayChannel(0, son[6], 0);
		
	if(Tir.Position.x-pos->x==0)//Si même ligne, c'est ok en x donc on annule le déplacement en x
	{
		Tir.sens.x=0;
	}
	else//si pas même ligne,   
	{
		if(Tir.Position.x-pos->x>0)//Si tir à droite de lorann, on met le sens vers la gauche
			Tir.sens.x=-1;
		else			//Sinon le tir est  à gauche de lorann, on met le sens vers la droite
			Tir.sens.x=1;
	}

	if(Tir.Position.y-pos->y==0)////Si même colonne, c'est ok en y
	{
		Tir.sens.y=0; //donc on annule le déplacement en y
	}
	else
	{
		if(Tir.Position.y-pos->y>0)//Si tir au dessous de lorann, on met le sens vers le haut
			Tir.sens.y=-1;
		else			//Sinon le tir est  à gauche de lorann, on met le sens vers la droite
			Tir.sens.y=1;
	}

	if(carte[Tir.Position.x+Tir.sens.x][Tir.Position.y+Tir.sens.y]!=' ')//si le sens trouvé ne mène pas  vers une case libre
	{
		Tir.sens.x=-Tir.sens.x;//inverser le tir
		Tir.sens.y=-Tir.sens.y;
		if(carte[Tir.Position.x+Tir.sens.x][Tir.Position.y+Tir.sens.y]!=' ') //si encore blocage, le tir s'arrête
		{
			Tir.sens.x=0;
			Tir.sens.y=0;
		}
	}
	return Tir;
}

struct Arme deplacer_tir(SDL_Rect *pos,char carte[][NB_BLOCS_HAUTEUR],struct Arme Tir)
{
    //ATTENTION, //ON ne peut pas commencer par un test de collision sur la carte
	//car JOUEUR est HORS de la carte, il faut tester en premier si le tir rencontre le joueur
	//par les var de position!!
	
	if(Tir.Position.x+Tir.sens.x==pos->x &&    Tir.Position.y+Tir.sens.y==pos->y ) // prochaine case= joueur?
	{
		Tir.sens.y=0;//on récupère le tir d'où sens=0
		Tir.sens.x=0;
		EtatTir=0;//on récupére le tir
		Tir.Position.x=-1;//et on place le tir hors de la carte de jeu
		Tir.Position.y=-1;		//alors le tir va disparaitre rapidement.pas obligé mais rend fluide la dispartiion du tir 		//sur joueur
	}
	else
	{	
        if(carte[Tir.Position.x+Tir.sens.x][Tir.Position.y+Tir.sens.y]==' ')//Si prochaine case vide
		{
			Tir.Position.y=Tir.Position.y+Tir.sens.y; // On bouge le tir en y
			Tir.Position.x=Tir.Position.x+Tir.sens.x; // On bouge le tir en x
		}
		else //sinon prochaine case = (obstacle inerte ou ennemi)
		{
			Tir.sens.x=-Tir.sens.x; //on inverse le sens du tir
			Tir.sens.y=-Tir.sens.y;
		    if(carte[Tir.Position.y+Tir.sens.y][Tir.Position.y+Tir.sens.y]==' ') //on reteste la prochaine case"
			{
                Tir.Position.y=Tir.Position.y+Tir.sens.y; //On bouge le tir en y
				Tir.Position.x=Tir.Position.x+Tir.sens.x; //On bouge le tir en x
			}
		}
	}
	return Tir;
}




/////////Fonction de déplacement du joueur.Tout se calcule en coordonnée tableau (par bloc de 32)->à améliorer : déplacement=vitesse*Delta timer

struct Joueur deplacerJoueur(char carte[][NB_BLOCS_HAUTEUR], struct Joueur joueur, SDL_Rect *pos_porte, long *pointeur_sur_score)
{
	if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]==' ')
	{
		joueur.Position.x=joueur.Position.x+joueur.sens.x;
		joueur.Position.y=joueur.Position.y+joueur.sens.y;
	}
    else
    {
                        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='+')//DIAMANT
        {
            Mix_PlayChannel(0, son[1], 0);
            *pointeur_sur_score=*pointeur_sur_score+5;
            joueur.nbVie++;
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
                if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='9')//DIAMANT
        {
            Mix_PlayChannel(0, son[1], 0);
            *pointeur_sur_score=*pointeur_sur_score+5;
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
        
        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='T' && carte[joueur.Position.x+joueur.sens.x+joueur.sens.x][joueur.Position.y+joueur.sens.y+joueur.sens.y]==' ') //TABLETTE
        {
            Mix_PlayChannel(0, son[5], 0);
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            carte[joueur.Position.x+joueur.sens.x+joueur.sens.x][joueur.Position.y+joueur.sens.y+joueur.sens.y]='T';
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='9')//DIAMANT
        {
            Mix_PlayChannel(0, son[1], 0);
            *pointeur_sur_score=*pointeur_sur_score+5;
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='8')//DIAMANT2
        {
            Mix_PlayChannel(0, son[1], 0);
            *pointeur_sur_score=*pointeur_sur_score+15;
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='F')//FIOLE
        {
            Mix_PlayChannel(0, son[1], 0);
            *pointeur_sur_score=*pointeur_sur_score+20;
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='C')//Joueur trouve CLE
        {
            Mix_PlayChannel(0, son[3], 0);
            carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=' ';
            carte[pos_porte->x][pos_porte->y]='V';//Ouvrir la porte.
            joueur.Position.x=joueur.Position.x+joueur.sens.x;
            joueur.Position.y=joueur.Position.y+joueur.sens.y;
        }
        if(carte[joueur.Position.x+joueur.sens.x][joueur.Position.y+joueur.sens.y]=='V')//Lorann passe sur porte ouverte : byebye
        {		
            continuer=finjeux();
        }
    }
			//if (carte[joueur.Position.x][joueur.Position.y - 1] == "3")//Si ennemi alors fin
			//	    finjeux();
	return joueur;
}//fin fonction deplacer



int finjeux()
{
    continuer=0;
    Mix_Music *musique_menu;
    musique_menu = Mix_LoadMUS("son/menu1.ogg");
    if(Mix_PlayMusic(musique_menu, 0) == -1)
        {
         printf("Impossible de jouer le son: %s\n", Mix_GetError());
         return 1;
         }
         return continuer;
}

//fonction de pause,on quitte aussi avec escape
void ma_pause()
{
    int continuer_pause = 1;
    SDL_Event event;

    while (continuer_pause)
    {
        SDL_WaitEvent(&event);
        switch(event.type)
        {
            case SDL_KEYDOWN:
              switch(event.key.keysym.sym)
                {
                    case SDLK_ESCAPE:
                    continuer_pause = 0;
                    default:
                    break;
                    
                }
                default:
                break;
        }
    }
}



void nettoyer_memoire()
{
}

