#include <SDL/SDL_mixer.h> //a réinclure sinon erreur sur sinFIn ennemi???

struct Partie
{
	long score;//score
	int nbVie;//nombre de vie
	int niveauTermine[5]; //niveau résolu 1=oui, 0=non
	int nb_victime;//nombre d'ennemis abbatus
};

struct Sens {
	int x;
	int y;
};
struct Arme
{
    struct Sens    sens;
    SDL_Rect         Position;
    Uint8               Etat;
    SDL_Surface *image;	//image
};
struct Joueur
{
	  struct Sens sens;
	  SDL_Rect Position;
	  int Etat;		//1=vivant, 0=mort
	  SDL_Surface *image;	//image
	  long int score;
	//  Uint8 direction;
	int nbVie;
};

struct Ennemi
{
	  struct Sens sens;
	  SDL_Rect Position;
	  Uint8 Etat;		//1=vivant, 0=mort
	  SDL_Surface *image;	//image

	  ///attributs propres aux monstres
      Mix_Chunk *sonFin;
	  char bonus;//8 diamant, F fiole...
	  int probaHV;		//probabilite de bouger horizontalement ou verticalement:  entre 0 et 100;
	  int pbChDir; //probabilité de changer de sens (rend plus ou moins chaotique le deplacement)
	  int dist_Detection; //distance de détection du joueur
	  int proba_Detection; //probabilite d'abandonner la poursuite (?? note2010 : à vérifier)
	  int proba_Tir; //proba d'éviter le tir entre 0 et 100;
	  int valeur;//valeur en nombre de points de l'ennemi
};
 
struct Partie jouer(SDL_Surface* ecran,long niveau,struct Partie prop_partie);

struct Joueur   deplacerJoueur(char carte[][NB_BLOCS_HAUTEUR], struct Joueur joueur, SDL_Rect *pos_porte, long *score);

void ma_pause();

int finjeux();

int chargerNiveau(char niveau[][NB_BLOCS_HAUTEUR],long numero_niveau);

struct Arme init_tir(SDL_Rect *pos, char carte[][NB_BLOCS_HAUTEUR], struct Arme Tir);

struct Arme  deplacer_tir(SDL_Rect *pos, char carte[][NB_BLOCS_HAUTEUR], struct  Arme Tir); 

struct Arme attirer_sort(SDL_Rect *pos,char carte[][NB_BLOCS_HAUTEUR],struct Arme Tir);

struct Ennemi  trouve_chemin(struct Ennemi monstre,char carte[][NB_BLOCS_HAUTEUR]);

struct Ennemi  suivre_joueur(struct Ennemi monstre,struct Joueur joueur);

struct Ennemi deplacer_ennemi(char carte[][NB_BLOCS_HAUTEUR], struct Ennemi monstre, struct Joueur joueur, struct Arme Tir, long *score);
void nettoyer_memoire();

struct Ennemi fin_ennemi(char carte[][NB_BLOCS_HAUTEUR],struct Ennemi monstre, struct Arme *Tir,long *score);
struct Arme fin_tir(struct Arme Tir);

