//#include <stdlib.h>
//#include <stdio.h>
#include <iostream>
using namespace std;
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "constantes.hpp"
#include "jeu.hpp"

  
int chargerNiveau(char niveau[][NB_BLOCS_HAUTEUR],long numero_niveau)
{
    
    int elementNiveau=0;   
    char carte1D[NB_BLOCS_LARGEUR*NB_BLOCS_HAUTEUR];
    memset(carte1D, ' ', sizeof(carte1D));//initialiser carte vide sinon des objets apparaissent au hasard...
  FILE *fichier_niveau=NULL;
    char s[30]; //chaine de caractère pour afficher numero de niveau
    sprintf(s, "niveaux/niveau00%ld.lvl", numero_niveau);
    fichier_niveau = fopen(s, "r");
    

//  fichier_niveau = fopen("niveau005.lvl", "r" );
  
  if(fichier_niveau==NULL)
  printf("impossible d'ouvrir le fichier de niveau\n");
  else
 {
    int cpt=0;
    while(elementNiveau != EOF)
    {
            elementNiveau = fgetc(fichier_niveau); // On lit le caractère
            if(elementNiveau==10)//10=retour ligne en ascii
            printf("\n");
            else
	    {            
	    carte1D[cpt]=elementNiveau;
	    printf("%c", carte1D[cpt]); // On l'affiche
	    cpt++;
	    }
	
    } // On continue tant que fgetc n'a pas retourné EOF (fin de fichier)
 }
fclose(fichier_niveau);
  
int i = 0, j = 0;




   
//avec i, balayage sur les ordonnees :Y=0:10=11
    for (i = 0 ; i < NB_BLOCS_HAUTEUR ; i++)
    {// avec j, balayage sur les abscisses X=0:19=20
        for (j = 0 ; j < NB_BLOCS_LARGEUR ; j++)
        { //printf("%c ",ligneFichier[(i * NB_BLOCS_LARGEUR) + j]);
            switch (carte1D[(i * NB_BLOCS_LARGEUR) + j])
            {
                case '0':
                    niveau[j][i] = '0';
                    break;
                case '1':
                    niveau[j][i] = '1';
                    break;
                case '2':
                    niveau[j][i] = '2';
                    break;
                case '3':
                    niveau[j][i] = '3';
                    break;
                case '4':
                    niveau[j][i] = '4';
                    break;
                case '5':
                    niveau[j][i] = '5';
                    break;
                case '|'://os vertical
                    niveau[j][i] = '|';
                    break;

                case ' '://
                    niveau[j][i] = ' ';
                    break;

                case 'F'://fiole
                    niveau[j][i] = 'F';
                    break;

                case '7':
			    niveau[j][i] = '7';
			    break;

                case '8':
                    niveau[j][i] = '8';
                    break;
                case '9'://diamaat
                    niveau[j][i] = '9';
                    break;
                case 'T'://tablette
                    niveau[j][i] = 'T';
                    break;
                case 'G'://golem
                    niveau[j][i] = 'G';
                    break;

                case 'D'://diable
                    niveau[j][i] = 'D';
                    break;


                case 'C'://clé
                    niveau[j][i] = 'C';
                    break;

		case 'P'://Porte fermee
			niveau[j][i] = 'P';
		break;
		case 'B'://Beholder
			niveau[j][i] = 'B';
		break;
		case '*':
			niveau[j][i] = '*';
		break;

		case '=':
			niveau[j][i] = '=';
		break;

        case '+':
        niveau[j][i]='+';
		case '\n':

		break;


            }

        }
    }

  
    return 1;
}


